--- flua-demos.lua - some sample flua programs (or almost).

-- Copyright (C) 2001 Eduardo Ochs.
-- Author:     Eduardo Ochs <edrx@mat.puc-rio.br>
-- Version:    0.01 (2001mar10).
--
-- This program was copylefted to prevent against patent psychopaths;
-- if you want a version with any other license you'll have to write
-- it yourself. More formally,
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License as
-- published by the Free Software Foundation; either version 2 of the
-- License, or (at your option) any later version.

-- Flua is an experimental Forth-like language, built on top of Lua, C
-- and Nasm. It is an implementation of the ideas of my (old) "Crim"
-- project.
--
-- Related files:
-- (find-angg "LUA/flua-0.01/inc.lua")
-- (find-angg "LUA/flua-0.01/flua-comp.lua")
-- (find-angg "LUA/flua-0.01/")




-- .flua_demo1	(to "flua_demo1")
-- .flua_demo2	(to "flua_demo2")
-- .flua_demo3	(to "flua_demo3")
-- .flua_demo4	(to "flua_demo4")
-- .flua_demo5	(to "flua_demo5")

-- (find-angg "LUA/flua-0.01/")
-- (find-angg "~/CRIM1/crim1a.tcl" "demos")



-- flua_demo1  (to ".flua_demo1")
function flua_demo1()
  tick("SQUARE"); f(": DUP * ;")			-- SQUARE ( n -- n^2 )
  tick("CUBE");   f(": DUP SQUARE * ;")			-- CUBE   ( n -- n^3 )
  tick("2");      f("CON");  nasm(4, "\tdd 2\n")	-- 2      ( -- 2 )
  gtick("DEMO");  f(": 2 CUBE ;")			-- DEMO   ( -- )
end


-- flua_demo2  (to ".flua_demo2")
function flua_demo2()
  add_SFprims("STO S> TOS >S")

  tick("&FOO"); f("AT:")				-- &FOO ( -- adr )
  tick("FOO!"); f("TO:")				-- FOO! ( w -- )
  tick("FOO");  f("CON:");  nasm(4, "\tdd 0x12345\n")	-- FOO  ( -- w )
  tick("S$@,"); f(": S> COUNT 2DUP + >S ;")		-- S$@, ( --
  tick("<.\">"); f("RSR:")
  tick("S<.\">"); f(": S$@, TYPE ;")
  tick("2<.\">"); f("RSR:")
  tick("S2<.\">"); f(":  S<.\"> S<.\"> ;")
  gtick("DEMO");   f(":  2<.\">");  dbstuff(6, "Hello\n", 6, "There\n")
                   f("   FOO FOO + FOO! ;")
end


-- flua_demo3  (to ".flua_demo3")
function flua_demo3()
  tick("strlen"); f("C1:");  nasm(4, "extern strlen\n\tdd strlen\n")
  tick("0<.\">"); f("RSR:")
  tick("S0<.\">"); f(":  S> DUP strlen 2DUP TYPE + 1 + >S ;")
  gtick("DEMO")    f(":  0<.\">");  dbstuff("Hello\n", 0)
	           f("   0<.\">");  dbstuff("There!\n", 0)
	           f("   ;")
end


-- flua_demo4  (to ".flua_demo4")
function flua_demo4()
  c1word("strlen")
  tick("0<.\">"); f("RSR:")
  tick("S0<.\">"); f(":  S> DUP strlen 2DUP TYPE + 1 + >S ;")
  tick("LITW");  f("RSR:  : SGOBBLE2 ;")

  function zdotquo(...) f("0<.\">"); call(dbstuff, arg) end
  function litw(n) f("LITW"); nasm(2, format("\tdw %s\n", n)) end
  function jlbl(name) lbl("LBL_" .. nasmify(name)) end
  function jd(name) nasm(2, format("\tdw LBL_%s-_f0\n", nasmify(name))) end

  tick("BRANCH");  f("RSR: :  SBRANCH ;")
  tick("0BRANCH"); f("RSR: : S0BRANCH ;")
  tick("YES/NO");  f("     :  0BRANCH");  jd("no");  zdotquo("yes\n", 0)
	           f("         BRANCH");  jd("end");
	                       jlbl("no");  zdotquo("no\n", 0)
		               jlbl("end"); f(";")
  gtick("DEMO");   f(":");  zdotquo("Hello\n", 0)
	                    litw(22);  f("YES/NO")
	                    litw(0);   f("YES/NO")
                            f(";")
end


-- flua_demo5  (to ".flua_demo5")
function flua_demo5()
  -- (find-luafile "src/lua/lua.c" "static void userinit (void) {")
  -- (find-fline "/usr/include/lualib.h")
  -- (find-fline "/usr/doc/lua/etc/trace.c")
  -- (find-luafile "loadlib.patch")

  strings.Cextras1 = [[
#include "lua.h"
#include "lualib.h"
void lua_stdlibsopen (lua_State *L) {
  lua_baselibopen(L);
  lua_iolibopen(L);
  lua_strlibopen(L);
  lua_mathlibopen(L);
  lua_dblibopen(L);
  /* extra libraries: */
  /* lua_rexlibopen(L); */
  /* lua_bitlibopen(L); */
  /* lua_loadlib_open(L); */
}
lua_State *lua_state = NULL;
#define	L	lua_state	/* lazy! */
]]

  add_Hprims(
"LUAC0 "," fun=*(funptr *)(_f0+RS[0]); DS[1]=(*fun)(L); RS--;"
       .." DS++; goto forth;",
"LUAC1 "," fun=*(funptr *)(_f0+RS[0]); DS[0]=(*fun)(L,DS[0]); RS--;"
       .." goto forth;",
"LUAC2 "," fun=*(funptr *)(_f0+RS[0]); DS[-1]=(*fun)(L,DS[-1],DS[0]);"
       .." DS--; RS--; goto forth;",
"LUAC3 "," fun=*(funptr *)(_f0+RS[0]); DS[-2]=(*fun)(L,DS[-2],DS[-1],DS[0]);"
       .." DS-=2; RS--; goto forth;"
  )
  -- LUAC0 ( R: ip0 ip  D:          -- R: ip0 D: retval )
  -- LUAC1 ( R: ip0 ip  D: p1       -- R: ip0 D: retval )
  -- LUAC2 ( R: ip0 ip  D: p1 p2    -- R: ip0 D: retval )
  -- LUAC3 ( R: ip0 ip  D: p1 p2 p3 -- R: ip0 D: retval )

  add_Fprims(
"lua_state "," DS[1]=(void *)lua_state; DS++; goto forth;",
"lua_state!"," lua_state=(void *)(DS[0]); DS--; goto forth;"
  )
  -- lua_state  ( -- luaS* )
  -- lua_state! ( luaS* -- )

  c1word("strlen")		    -- strlen ( adr -- len )
  tick("0$"); f("RSR:")		    -- S0$    ( S: adr -- S: adr+len+1 D: adr )
  tick("S0$"); f(":  S> DUP DUP strlen + 1 + >S ;")
  function zstr(str) f("0$") dbstuff(str, 0) end

  -- (find-node "(lua)States" "lua_State *lua_open")
  -- (find-node "(lua)Pushing Values Onto The Stack" "lua_pushstring")
  -- (find-node "(lua)Calling Lua Functions")
  --
  cnword("lua_open", "C0:")
  cnword("lua_stdlibsopen", "DROPPING: LUAC0:")
  cnword("lua_getglobal",   "DROPPING: LUAC1:")
  cnword("lua_pushstring",  "DROPPING: LUAC1:")
  cnword("lua_call",        "DROPPING: LUAC2:")
  -- lua_open        ( -- lua_State* )
  -- lua_stdlibsopen ( -- )
  -- lua_getglobal   ( $adr -- )
  -- lua_pushstring  ( $adr -- )
  -- lua_call        ( nargs nresults -- )

  gtick("DEMO");  f(":  lua_open lua_state!  lua_stdlibsopen")
                  zstr("print");  f("lua_getglobal")
                  zstr("Hello");  f("lua_pushstring")
                  f("1 0 lua_call")
                  f(";")
end







-- (find-es "crim" "crim1b")
-- (find-angg "LUA/inc.lua")
-- (find-angg "LUA/engine0.skel.c")
-- (find-angg "LUA/nasmskel.asm")
-- (find-fline "~/tmp/lua-manual.txt")

-- (find-fline "/usr/include/")
-- (find-fline "/usr/include/lua.h")
-- (find-fline "/usr/include/luadebug.h")
-- (find-fline "/usr/include/lualib.h")






--
-- Local Variables:
-- coding:               no-conversion
-- ee-anchor-format:     "%s"
-- ee-charset-indicator: ""
-- End:
